# https://graphql.org/learn/schema/
# https://www.graphql-scalars.dev/docs/scalars

scalar DateTime
scalar EmailAddress
scalar URL
scalar JSONObject

# https://github.com/confuser/graphql-constraint-directive
directive @constraint(
  # String constraints
  minLength: Int
  maxLength: Int
  startsWith: String
  endsWith: String
  contains: String
  notContains: String
  pattern: String
  format: String
  # Number constraints
  min: Float
  max: Float
  exclusiveMin: Float
  exclusiveMax: Float
  multipleOf: Float
  uniqueTypeName: String
) on INPUT_FIELD_DEFINITION | FIELD_DEFINITION

interface Node {
  id: ID!
}

input ConnectionInput {
  first: Int! = 10
  after: String
}

type PageInfo {
  hasNextPage: Boolean!
  hasPreviousPage: Boolean!
  startCursor: String
  endCursor: String
}

input FilterStringInput {
  equals: String
  in: [String!]
  notIn: [String!]
  contains: String
  startsWith: String
  endsWith: String
  not: FilterStringInput
}

input FilterTextInput {
  """
  fulltext search
  """
  search: String
  contains: String
  startsWith: String
  endsWith: String
}

input FilterIntInput {
  equals: Int
  in: [Int!]
  notIn: [Int!]
  """
  target > value
  """
  gt: Int
  """
  target < value
  """
  lt: Int
  """
  target >= value
  """
  gte: Int
  """
  target <= value
  """
  lte: Int
  not: FilterIntInput
}

input FilterFloatInput {
  equals: Float
  in: [Float!]
  notIn: [Float!]
  """
  target > value
  """
  gt: Float
  """
  target < value
  """
  lt: Float
  """
  target >= value
  """
  gte: Float
  """
  target <= value
  """
  lte: Float
  not: FilterFloatInput
}

input FilterDateTimeInput {
  equals: DateTime
  in: [DateTime!]
  notIn: [DateTime!]
  """
  target > value
  """
  gt: DateTime
  """
  target < value
  """
  lt: DateTime
  """
  target >= value
  """
  gte: DateTime
  """
  target <= value
  """
  lte: DateTime
  not: FilterDateTimeInput
}

input UpdateIntInput {
  set: Int
  increment: Int
  decrement: Int
}
